/* Copyright 2009 Fog Creek Software, Inc. */

using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

/* FogBugz namespaces-- make sure you add the neccesary assembly references to
 * the following DLL files contained in C:\Program Files\FogBugz\Website\bin\ 
 * FogBugz.dll, FogCreek.Plugins.dll, FogCreek.Plugins.InterfaceEvents.dll     */
using FogCreek.FogBugz.Plugins;
using FogCreek.FogBugz.Plugins.Api;
using FogCreek.FogBugz.Plugins.Entity;
using FogCreek.FogBugz.Plugins.Interfaces;
using FogCreek.FogBugz;

namespace IPluginWikiPageDisplay_Example
{
    /* Class Declaration: Inherit from Plugin, expose IPluginWikiPageDisplay */
    public class IPluginWikiPageDisplay_Example : Plugin, IPluginWikiPageDisplay, IPluginStaticFile
    {
        /* Constructor: We'll just initialize the inherited Plugin class, which 
         * takes the passed instance of CPluginApi and sets its "api" member variable. */
        public IPluginWikiPageDisplay_Example(CPluginApi api)
            : base(api)
        {
        }
        
        #region IPluginWikiPageDisplay Members

        /* We're not going to modify the diff view in this example */
        public string WikiPageDisplayDiff(CWikiPage page, string sContents)
        {
            return sContents;
        }

        /* We're not going to modify the edit view in this example */
        public string WikiPageDisplayEdit(CWikiPage page, string sContents)
        {
            return sContents;
        }

        /* Find every instance of the word "kiwi" in the html contents of the wiki
         * page and replace it with an img tag with a static plugin file as the src */
        public string WikiPageDisplayView(CWikiPage page, string sContents)
        {
            System.Text.RegularExpressions.Regex match = new System.Text.RegularExpressions.Regex("kiwi", System.Text.RegularExpressions.RegexOptions.IgnoreCase);
            return match.Replace(sContents,
                     string.Format(@"<img src=""{0}"" title=""kiwi"" />",
                                   api.Url.PluginStaticFileUrl("kiwi25.gif")
                                  )
                    );
        }

        #endregion

        #region IPluginStaticFile Members

        /* Set the visibility of the kiwi image we use to public */
        public PermissionLevel StaticFileVisibility(string sFilename)
        {
            return (sFilename == "kiwi25.gif") ? PermissionLevel.Public
                                               : PermissionLevel.Administrator;
        }

        public void StaticFileHeaders(string sFilename)
        {
        }

        #endregion
    }
}